package alxtree;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.Component;
import java.awt.Color;

/**
 * Titre : AlxBufferedImage
 * Description : pour tenter de remplacer le <CODE>BufferedImage</CODE> du SDK1.2
 * @author <A href=alapetite@fr.st>Alexandre Alapetite</A>
 * @version 1.0
 * @see BufferedImage
 */
public class AlxBufferedImage extends Object
{
  public Image image;
  private Graphics graphics;
  private int width=0;
  private int height=0;

  public AlxBufferedImage(int width, int height, Component pere)
  {
    super();
    this.width=width;
    this.height=height;
    this.image = pere.createImage(width,height);
    this.graphics=this.image.getGraphics();
  }

  public int getWidth()
  {
    return this.width;
  }

  public int getHeight()
  {
    return this.height;
  }

  public Graphics getGraphics()
  {
    return this.graphics;
  }

  public void setRGB(int x, int y, int rvb)
  {
    Color origine=graphics.getColor();
    graphics.setColor(new Color(rvb));
    graphics.drawLine(x,y,x,y);
    graphics.setColor(origine);
  }
}