package alxtree;

import java.awt.BorderLayout;
//import java.awt.Color;
import java.awt.Graphics;
import java.awt.Dimension;
import java.awt.Panel;
import java.awt.Scrollbar;
import java.awt.event.AdjustmentListener;
import java.awt.event.AdjustmentEvent;

/**
 * Titre : AlxTreeContainer
 * Description : Panel destin  contenir un AlxTree. Avec Scrollbar
 * @author <A href=alapetite@fr.st>Alexandre Alapetite</A>
 * @version 1.0
 * @see AlxTree
 */
public class AlxTreeContainer extends Panel implements AlxTreeListener,AdjustmentListener
{
  private AlxTree alxTree;
  Scrollbar scrollbar1;

  public AlxTreeContainer()
  {
    this(new AlxTree());
  }

  public AlxTreeContainer(AlxTree alxTree)
  {
    super();
    this.alxTree=alxTree;
    initGraphique();
    alxTree.addChangeListener(this);
    scrollbar1.addAdjustmentListener(this);
  }

  public void alxTreeChanged(AlxTreeEvent ate)
  {
    //scrollbar1.setVisibleAmount(this.getHeight());
    //scrollbar1.setMaximum(alxTree.getHeight());
    scrollbar1.setValues(scrollbar1.getValue(),this.getHeight(),0,alxTree.getHeight());
    alxTree.setLocation(0,-scrollbar1.getValue());
    scrollbar1.setVisible(alxTree.getHeight()>this.getHeight());
    if (scrollbar1.isVisible()) this.alxTree.setSize(this.getWidth()-scrollbar1.getSize().width,this.alxTree.getHeight());
    else this.alxTree.setSize(this.getWidth(),this.alxTree.getHeight());
  }

  public void adjustmentValueChanged(AdjustmentEvent e)
  {
    alxTree.setLocation(0,-scrollbar1.getValue());
  }

  public AlxTree getAlxTree()
  {
    return this.alxTree;
  }

  public void setAlxTree(AlxTree alxTree)
  {
    this.alxTree=alxTree;
  }

  /** rcriture car indisponible en JDK1.1 */
  public int getHeight()
  {
    return this.getSize().height;
  }

  /** rcriture car indisponible en JDK1.1 */
  public int getWidth()
  {
    return this.getSize().width;
  }

  public void setSize(int width, int height)
  {
    this.alxTree.setSize(width-20,this.alxTree.getHeight());
    super.setSize(width,height);
  }

  /*public void setBackground(Color c)
  {
    super.setBackground(c);
    this.alxTree.setBackground(c);
  }

  public void setForeground(Color c)
  {
    super.setForeground(c);
    this.alxTree.setForeground(c);
  }*/

  void initGraphique()
  {
    //this.setBounds(0,0,100,100);
    //this.setBackground(alxTree.getBackground());
    this.setLayout(new BorderLayout());
    this.add(this.alxTree, BorderLayout.CENTER);
    scrollbar1=new Scrollbar();
    //scrollbar1.setValues(0,this.getHeight(),0,alxTree.getHeight()); //marche pas - ???
    //scrollbar1.setVisible(alxTree.getHeight()>this.getHeight());
    this.add(scrollbar1, BorderLayout.EAST);
    this.validate();
  }

  public void paint(Graphics graphics)
  {
    super.paint(graphics);
    graphics.setColor(alxTree.getBackground());
    graphics.fillRect(0,alxTree.getHeight(),this.getWidth(),this.getHeight()-alxTree.getHeight());
  }
}
