package clientarbres;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import alxtree.*;

public class AppletClientArbres extends Applet implements AlxTreeListener
{
  //boolean isStandalone = false;
  AlxTreeContainer alxTreeContainer;
  private String appletAdresse;
  private String paramCouleur;
  private String paramBasefichier;
  private String paramFichier;
  private String paramDefaut;

  /*public AppletClientArbres()
  {
   super();
  }*/

  /**Initialiser l'applet*/
  public void init()
  {
    try
    {
      lireParametres();
      lireFichierArbre();
      jbInit();
      alxTreeContainer.getAlxTree().addChangeListener(this);
    }
    catch(Exception e) {e.printStackTrace(); }
  }

  /** lit tous les paramtres transmis  l'applet et met des valeurs par dfaut si ncessaire */
  private void lireParametres()
  {
    appletAdresse=this.getCodeBase().toString();
    try
    {
      paramCouleur = getParameter("couleur","FFFFFF");
      paramBasefichier = getParameter("basefichier",".");
      paramFichier = getParameter("fichier","arbre.txt");
      paramDefaut = getParameter("defaut","defaut.html");
    }
    catch (Exception e) {System.out.println(e.toString()); }
    if (paramBasefichier.equals(".")) paramBasefichier=appletAdresse;
    //if (paramFichier.length()<5) paramFichier="arbre.txt";
    //if (paramDefaut.length()<5) paramDefaut="defaut.html";
  }

  /** en rponse  un vnement sur <CODE>AlxTreeContainer</CODE> */
  public void alxTreeChanged(AlxTreeEvent ate)
  {
    try
    {
      AlxNoeud alxNoeud = ate.getAlxNoeud();
      if (alxNoeud.isFeuille())
        if (alxNoeud.isOuvert())
          this.getAppletContext().showDocument(new URL(appletAdresse+alxNoeud.getChemin()+"/index.html"),"est");
        else
          this.getAppletContext().showDocument(new URL(appletAdresse+paramDefaut),"est");
    }
    catch (MalformedURLException mue) {System.out.println(mue.toString()); }
  }

  /** lit le fichier dont l'adresse est passe en paramtre pour crer l'arborescence
   *  @see AlxTreeContainer
   *  @see AlxTree
   *  @see AlxNoeud
   */
  private void lireFichierArbre()
  {
    try
    {
      URL url = new URL(paramBasefichier+paramFichier);
      InputStreamReader connection = new InputStreamReader(url.openStream());
      BufferedReader fichier = new BufferedReader(connection);

      AlxNoeud temp = new AlxNoeud("temp"); //racine temporaire
      ajouteFils(temp,fichier); //lecture rcursive du fichier et cration d'un arbre de AlxNoeud
      alxTreeContainer = new AlxTreeContainer(new AlxTree(temp.getFilsAt(1))); //cration du nouvel AlxTree
      temp.getFilsAt(1).setPere(null); //destruction de la racine temporaire
      fichier.close();
      connection.close();
    }
    catch (Exception e) {System.out.println(e.toString()); }
  }

  /** sous mthode rcursive de <CODE>lireFichierArbre()</CODE>
   *  @see #lireFichierArbre()
   */
  private void ajouteFils(AlxNoeud pere, BufferedReader fichier) throws IOException
  {
    AlxNoeud moi = new AlxNoeud(fichier.readLine());
    pere.addFils(moi);
    int cpt = Integer.parseInt(fichier.readLine());
    if (cpt>0) //S'il a des fils
      for (int i=1; i<=cpt; i++) ajouteFils(moi,fichier);
  }

  /**Initialiser le composant*/
  private void jbInit() throws Exception
  {
    this.setLayout(new BorderLayout());
    alxTreeContainer.getAlxTree().setBackground(new Color(Integer.valueOf(paramCouleur,16).intValue()));
    this.add(alxTreeContainer, BorderLayout.CENTER);
  }

  /**Obtenir une valeur de paramtre*/
  public String getParameter(String key, String def) throws Exception
  {
    return //isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  /**Obtenir les informations d'applet*/
  /*public String getAppletInfo()
  {
    return "Information applet";
  }*/
  /**Obtenir les informations de paramtre*/
  /*public String[][] getParameterInfo()
  {
    return null;
  }*/

  /**Mthode principale*/
 /* public static void main(String[] args)
  {
    AppletClientArbres applet = new AppletClientArbres();
    applet.isStandalone = true;
    Frame frame;
    frame = new Frame()
    {
      protected void processWindowEvent(WindowEvent e)
      {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING)
        {
          System.exit(0);
        }
      }
      public synchronized void setTitle(String title)
      {
        super.setTitle(title);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      }
    };
    frame.setTitle("Cadre de l'applet");
    frame.add(applet, BorderLayout.CENTER);
    applet.init();
    applet.start();
    frame.setSize(200,200);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);
  }*/
}
